diff --exclude=CVS -Nru certi/include/baseTypes.hh certi.new/include/baseTypes.hh
--- certi/include/baseTypes.hh	2008-09-29 14:31:28.000000000 +0200
+++ certi.new/include/baseTypes.hh	2008-11-26 10:26:07.000000000 +0100
@@ -17,7 +17,7 @@
     RTI_TRUE
 };
 
-class CERTI_EXPORT Exception
+class RTI_EXPORT Exception
 {
 public:
     ULong _serial ;
@@ -35,7 +35,7 @@
 };
 
 #define RTI_EXCEPT(A) \
-class CERTI_EXPORT A : public Exception { \
+class RTI_EXPORT A : public Exception { \
 public: \
     static const char *_ex ; \
     static long type ; \
diff --exclude=CVS -Nru certi/include/certi.hh certi.new/include/certi.hh
--- certi/include/certi.hh	2008-10-28 13:07:26.000000000 +0100
+++ certi.new/include/certi.hh	2008-11-26 14:25:29.000000000 +0100
@@ -98,10 +98,8 @@
 
 // RTI Shortcuts
 typedef RTI::AttributeHandle AttributeHandle ;
-typedef RTI::AttributeHandleSet AttributeHandleSet ;
 typedef RTI::DimensionHandle DimensionHandle ;
 typedef RTI::EventRetractionHandle EventRetractionHandle ;
-typedef RTI::Exception Exception ;
 typedef RTI::ExtentIndex ExtentIndex ;
 typedef RTI::FederateHandle FederateHandle ;
 typedef RTI::Handle Handle ;
@@ -115,113 +113,6 @@
 typedef RTI::ULong ULong ;
 typedef RTI::UShort UShort ;
 
-// RTI Shortcuts (exceptions)
-typedef RTI::ArrayIndexOutOfBounds ArrayIndexOutOfBounds ;
-typedef RTI::AsynchronousDeliveryAlreadyDisabled AsynchronousDeliveryAlreadyDisabled ;
-typedef RTI::AsynchronousDeliveryAlreadyEnabled  AsynchronousDeliveryAlreadyEnabled ;
-typedef RTI::AttributeAcquisitionWasNotRequested AttributeAcquisitionWasNotRequested ;
-typedef RTI::AttributeAcquisitionWasNotCanceled AttributeAcquisitionWasNotCanceled ;
-typedef RTI::AttributeAlreadyBeingAcquired AttributeAlreadyBeingAcquired ;
-typedef RTI::AttributeAlreadyBeingDivested AttributeAlreadyBeingDivested ;
-typedef RTI::AttributeAlreadyOwned AttributeAlreadyOwned ;
-typedef RTI::AttributeDivestitureWasNotRequested AttributeDivestitureWasNotRequested ;
-typedef RTI::AttributeNotDefined AttributeNotDefined ;
-typedef RTI::AttributeNotKnown AttributeNotKnown ;
-typedef RTI::AttributeNotOwned AttributeNotOwned ;
-typedef RTI::AttributeNotPublished AttributeNotPublished ;
-typedef RTI::ConcurrentAccessAttempted ConcurrentAccessAttempted ;
-typedef RTI::CouldNotDiscover CouldNotDiscover ;
-typedef RTI::CouldNotOpenFED CouldNotOpenFED ;
-typedef RTI::CouldNotRestore CouldNotRestore ;
-typedef RTI::DeletePrivilegeNotHeld DeletePrivilegeNotHeld ;
-typedef RTI::DimensionNotDefined DimensionNotDefined ;
-typedef RTI::EnableTimeConstrainedPending EnableTimeConstrainedPending ;
-typedef RTI::EnableTimeConstrainedWasNotPending EnableTimeConstrainedWasNotPending ;
-typedef RTI::EnableTimeRegulationPending EnableTimeRegulationPending ;
-typedef RTI::EnableTimeRegulationWasNotPending EnableTimeRegulationWasNotPending ;
-typedef RTI::ErrorReadingFED ErrorReadingFED ;
-typedef RTI::EventNotKnown EventNotKnown ;
-typedef RTI::FederateAlreadyExecutionMember FederateAlreadyExecutionMember ;
-typedef RTI::FederateInternalError FederateInternalError ;
-typedef RTI::FederateLoggingServiceCalls FederateLoggingServiceCalls ;
-typedef RTI::FederateNotExecutionMember FederateNotExecutionMember ;
-typedef RTI::FederateOwnsAttributes FederateOwnsAttributes ;
-typedef RTI::FederateWasNotAskedToReleaseAttribute FederateWasNotAskedToReleaseAttribute ;
-typedef RTI::FederatesCurrentlyJoined FederatesCurrentlyJoined ;
-typedef RTI::FederationExecutionAlreadyExists FederationExecutionAlreadyExists ;
-typedef RTI::FederationExecutionDoesNotExist FederationExecutionDoesNotExist ;
-typedef RTI::FederationTimeAlreadyPassed FederationTimeAlreadyPassed ;
-typedef RTI::HandleValuePairMaximumExceeded HandleValuePairMaximumExceeded ;
-typedef RTI::InteractionClassNotDefined InteractionClassNotDefined ;
-typedef RTI::InteractionClassNotKnown InteractionClassNotKnown ;
-typedef RTI::InteractionClassNotPublished InteractionClassNotPublished ;
-typedef RTI::InteractionClassNotSubscribed InteractionClassNotSubscribed ;
-typedef RTI::InteractionParameterNotDefined InteractionParameterNotDefined ;
-typedef RTI::InteractionParameterNotKnown InteractionParameterNotKnown ;
-typedef RTI::InvalidExtents InvalidExtents ;
-typedef RTI::InvalidFederationTime InvalidFederationTime ;
-typedef RTI::InvalidHandleValuePairSetContext InvalidHandleValuePairSetContext ;
-typedef RTI::InvalidLookahead InvalidLookahead ;
-typedef RTI::InvalidOrderingHandle InvalidOrderingHandle ;
-typedef RTI::InvalidRegionContext InvalidRegionContext ;
-typedef RTI::InvalidResignAction InvalidResignAction ;
-typedef RTI::InvalidRetractionHandle InvalidRetractionHandle ;
-typedef RTI::InvalidTransportationHandle InvalidTransportationHandle ;
-typedef RTI::MemoryExhausted MemoryExhausted ;
-typedef RTI::NameNotFound NameNotFound ;
-typedef RTI::ObjectClassNotDefined ObjectClassNotDefined ;
-typedef RTI::ObjectClassNotKnown ObjectClassNotKnown ;
-typedef RTI::ObjectClassNotPublished ObjectClassNotPublished ;
-typedef RTI::ObjectClassNotSubscribed ObjectClassNotSubscribed ;
-typedef RTI::ObjectNotKnown ObjectNotKnown ;
-typedef RTI::ObjectAlreadyRegistered ObjectAlreadyRegistered ;
-typedef RTI::OwnershipAcquisitionPending OwnershipAcquisitionPending ;
-typedef RTI::RegionInUse RegionInUse ;
-typedef RTI::RegionNotKnown RegionNotKnown ;
-typedef RTI::RestoreInProgress RestoreInProgress ;
-typedef RTI::RestoreNotRequested RestoreNotRequested ;
-typedef RTI::RTIinternalError RTIinternalError ;
-typedef RTI::SpaceNotDefined SpaceNotDefined ;
-typedef RTI::SaveInProgress SaveInProgress ;
-typedef RTI::SaveNotInitiated SaveNotInitiated ;
-typedef RTI::SpecifiedSaveLabelDoesNotExist SpecifiedSaveLabelDoesNotExist ;
-typedef RTI::SynchronizationPointLabelWasNotAnnounced SynchronizationPointLabelWasNotAnnounced ;
-typedef RTI::TimeAdvanceAlreadyInProgress TimeAdvanceAlreadyInProgress ;
-typedef RTI::TimeAdvanceWasNotInProgress TimeAdvanceWasNotInProgress ;
-typedef RTI::TimeConstrainedAlreadyEnabled TimeConstrainedAlreadyEnabled ;
-typedef RTI::TimeConstrainedWasNotEnabled TimeConstrainedWasNotEnabled ;
-typedef RTI::TimeRegulationAlreadyEnabled TimeRegulationAlreadyEnabled ;
-typedef RTI::TimeRegulationWasNotEnabled TimeRegulationWasNotEnabled ;
-typedef RTI::UnableToPerformSave UnableToPerformSave ;
-typedef RTI::ValueCountExceeded ValueCountExceeded ;
-typedef RTI::ValueLengthExceeded ValueLengthExceeded ;
-
-// CERTI Exception-derived Exceptions (including deprecated HLA exceptions)
-RTI_EXCEPT(FederateNotPublishing)
-RTI_EXCEPT(FederateNotSubscribing)
-RTI_EXCEPT(InvalidObjectHandle)
-RTI_EXCEPT(SecurityError)
-RTI_EXCEPT(CouldNotOpenRID)
-RTI_EXCEPT(ErrorReadingRID)
-RTI_EXCEPT(FederationAlreadyPaused)
-RTI_EXCEPT(FederationNotPaused)
-RTI_EXCEPT(AttributeNotSubscribed)
-RTI_EXCEPT(FederateAlreadyPaused)
-RTI_EXCEPT(FederateDoesNotExist)
-RTI_EXCEPT(FederateNameAlreadyInUse)
-RTI_EXCEPT(FederateNotPaused)
-RTI_EXCEPT(IDsupplyExhausted)
-RTI_EXCEPT(InvalidDivestitureCondition)
-RTI_EXCEPT(InvalidFederationTimeDelta)
-RTI_EXCEPT(InvalidRoutingSpace)
-RTI_EXCEPT(NoPauseRequested)
-RTI_EXCEPT(NoResumeRequested)
-RTI_EXCEPT(TooManyIDsRequested)
-RTI_EXCEPT(UnimplementedService)
-RTI_EXCEPT(UnknownLabel)
-RTI_EXCEPT(NetworkSignal)
-RTI_EXCEPT(NetworkError)
-
 typedef RTI::Double FederationTime ;
 typedef UShort ObjectHandlecount ;
 typedef std::string ObjectName_t ;
diff --exclude=CVS -Nru certi/libCERTI/CMakeLists.txt certi.new/libCERTI/CMakeLists.txt
--- certi/libCERTI/CMakeLists.txt	2008-12-03 11:23:54.000000000 +0100
+++ certi.new/libCERTI/CMakeLists.txt	2008-12-05 12:33:43.000000000 +0100
@@ -46,7 +46,6 @@
 )
 
 SET(CERTI_OWNERSHIP_SRCS
-GAV_aux.cc
 GAV.cc
 GAV.hh
 )
@@ -225,8 +224,9 @@
     ${FEDTIME_SRCS}
 )
 
+TARGET_LINK_LIBRARIES(FedTime RTI)
+
 SET_TARGET_PROPERTIES(FedTime PROPERTIES PROJECT_LABEL LibFedTime)
-                        
 IF (MINGW)
     SET_TARGET_PROPERTIES(FedTime PROPERTIES LINK_FLAGS "-Wl,--output-def,${LIBRARY_OUTPUT_PATH}/libFedTime.def")
     INSTALL(FILES ${LIBRARY_OUTPUT_PATH}/libFedTime.def
diff --exclude=CVS -Nru certi/libCERTI/Exception.cc certi.new/libCERTI/Exception.cc
--- certi/libCERTI/Exception.cc	2008-11-25 17:32:14.000000000 +0100
+++ certi.new/libCERTI/Exception.cc	2008-12-05 17:19:44.000000000 +0100
@@ -26,55 +26,110 @@
 #include "certi.hh"
 
 // static members for HLA Exceptions
-const char *certi::FederateNotPublishing::_ex = "FederateNotPublishing" ;
-const char *certi::FederateNotSubscribing::_ex = "FederateNotSubscribing" ;
-const char *certi::InvalidObjectHandle::_ex = "InvalidObjectHandle" ;
-const char *certi::SecurityError::_ex = "SecurityError" ;
-const char *certi::CouldNotOpenRID::_ex = "CouldNotOpenRID" ;
-const char *certi::ErrorReadingRID::_ex = "ErrorReadingRID" ;
-const char *certi::FederationAlreadyPaused::_ex = "FederationAlreadyPaused" ;
-const char *certi::FederationNotPaused::_ex = "FederationNotPaused" ;
-const char *certi::AttributeNotSubscribed::_ex = "AttributeNotSubscribed" ;
-const char *certi::FederateAlreadyPaused::_ex = "FederateAlreadyPaused" ;
-const char *certi::FederateDoesNotExist::_ex = "FederateDoesNotExist" ;
-const char *certi::FederateNameAlreadyInUse::_ex = "FederateNameAlreadyInUse" ;
-const char *certi::FederateNotPaused::_ex = "FederateNotPaused" ;
-const char *certi::IDsupplyExhausted::_ex = "IDsupplyExhausted" ;
-const char *certi::InvalidDivestitureCondition::_ex = "InvalidDivestitureCondition" ;
-const char *certi::InvalidFederationTimeDelta::_ex = "InvalidFederationTimeDelta" ;
-const char *certi::InvalidRoutingSpace::_ex = "InvalidRoutingSpace" ;
-const char *certi::NoPauseRequested::_ex = "NoPauseRequested" ;
-const char *certi::NoResumeRequested::_ex = "NoResumeRequested" ;
-const char *certi::TooManyIDsRequested::_ex = "TooManyIDsRequested" ;
-const char *certi::UnimplementedService::_ex = "UnimplementedService" ;
-const char *certi::UnknownLabel::_ex = "UnknownLabel" ;
-const char *certi::NetworkError::_ex = "NetworkError" ;
-const char *certi::NetworkSignal::_ex = "NetworkSignal" ;
+long certi::ArrayIndexOutOfBounds::_type = certi::e_ArrayIndexOutOfBounds ;
+long certi::AsynchronousDeliveryAlreadyDisabled::_type = certi::e_AsynchronousDeliveryAlreadyDisabled ;
+long certi::AsynchronousDeliveryAlreadyEnabled::_type = certi::e_AsynchronousDeliveryAlreadyEnabled ;
+long certi::AttributeAcquisitionWasNotRequested::_type = certi::e_AttributeAcquisitionWasNotRequested ;
+long certi::AttributeAcquisitionWasNotCanceled::_type = certi::e_AttributeAcquisitionWasNotCanceled ;
+long certi::AttributeAlreadyBeingAcquired::_type = certi::e_AttributeAlreadyBeingAcquired ;
+long certi::AttributeAlreadyBeingDivested::_type = certi::e_AttributeAlreadyBeingDivested ;
+long certi::AttributeAlreadyOwned::_type = certi::e_AttributeAlreadyOwned ;
+long certi::AttributeDivestitureWasNotRequested::_type = certi::e_AttributeDivestitureWasNotRequested ;
+long certi::AttributeNotDefined::_type = certi::e_AttributeNotDefined ;
+long certi::AttributeNotKnown::_type = certi::e_AttributeNotKnown ;
+long certi::AttributeNotOwned::_type = certi::e_AttributeNotOwned ;
+long certi::AttributeNotPublished::_type = certi::e_AttributeNotPublished ;
+long certi::ConcurrentAccessAttempted::_type = certi::e_ConcurrentAccessAttempted ;
+long certi::CouldNotDiscover::_type = certi::e_CouldNotDiscover ;
+long certi::CouldNotOpenFED::_type = certi::e_CouldNotOpenFED ;
+long certi::CouldNotRestore::_type = certi::e_CouldNotRestore ;
+long certi::DeletePrivilegeNotHeld::_type = certi::e_DeletePrivilegeNotHeld ;
+long certi::DimensionNotDefined::_type = certi::e_DimensionNotDefined ;
+long certi::EnableTimeConstrainedPending::_type = certi::e_EnableTimeConstrainedPending ;
+long certi::EnableTimeConstrainedWasNotPending::_type = certi::e_EnableTimeConstrainedWasNotPending ;
+long certi::EnableTimeRegulationPending::_type = certi::e_EnableTimeRegulationPending ;
+long certi::EnableTimeRegulationWasNotPending::_type = certi::e_EnableTimeRegulationWasNotPending ;
+long certi::ErrorReadingFED::_type = certi::e_ErrorReadingFED ;
+long certi::EventNotKnown::_type = certi::e_EventNotKnown ;
+long certi::FederateAlreadyExecutionMember::_type = certi::e_FederateAlreadyExecutionMember ;
+long certi::FederateInternalError::_type = certi::e_FederateInternalError ;
+long certi::FederateLoggingServiceCalls::_type = certi::e_FederateLoggingServiceCalls ;
+long certi::FederateNotExecutionMember::_type = certi::e_FederateNotExecutionMember ;
+long certi::FederateOwnsAttributes::_type = certi::e_FederateOwnsAttributes ;
+long certi::FederateWasNotAskedToReleaseAttribute::_type = certi::e_FederateWasNotAskedToReleaseAttribute ;
+long certi::FederatesCurrentlyJoined::_type = certi::e_FederatesCurrentlyJoined ;
+long certi::FederationExecutionAlreadyExists::_type = certi::e_FederationExecutionAlreadyExists ;
+long certi::FederationExecutionDoesNotExist::_type = certi::e_FederationExecutionDoesNotExist ;
+long certi::FederationTimeAlreadyPassed::_type = certi::e_FederationTimeAlreadyPassed ;
+long certi::HandleValuePairMaximumExceeded::_type = certi::e_HandleValuePairMaximumExceeded ;
+long certi::InteractionClassNotDefined::_type = certi::e_InteractionClassNotDefined ;
+long certi::InteractionClassNotKnown::_type = certi::e_InteractionClassNotKnown ;
+long certi::InteractionClassNotPublished::_type = certi::e_InteractionClassNotPublished ;
+long certi::InteractionClassNotSubscribed::_type = certi::e_InteractionClassNotSubscribed ;
+long certi::InteractionParameterNotDefined::_type = certi::e_InteractionParameterNotDefined ;
+long certi::InteractionParameterNotKnown::_type = certi::e_InteractionParameterNotKnown ;
+long certi::InvalidExtents::_type = certi::e_InvalidExtents ;
+long certi::InvalidFederationTime::_type = certi::e_InvalidFederationTime ;
+long certi::InvalidHandleValuePairSetContext::_type = certi::e_InvalidHandleValuePairSetContext ;
+long certi::InvalidLookahead::_type = certi::e_InvalidLookahead ;
+long certi::InvalidOrderingHandle::_type = certi::e_InvalidOrderingHandle ;
+long certi::InvalidRegionContext::_type = certi::e_InvalidRegionContext ;
+long certi::InvalidResignAction::_type = certi::e_InvalidResignAction ;
+long certi::InvalidRetractionHandle::_type = certi::e_InvalidRetractionHandle ;
+long certi::InvalidTransportationHandle::_type = certi::e_InvalidTransportationHandle ;
+long certi::MemoryExhausted::_type = certi::e_MemoryExhausted ;
+long certi::NameNotFound::_type = certi::e_NameNotFound ;
+long certi::ObjectClassNotDefined::_type = certi::e_ObjectClassNotDefined ;
+long certi::ObjectClassNotKnown::_type = certi::e_ObjectClassNotKnown ;
+long certi::ObjectClassNotPublished::_type = certi::e_ObjectClassNotPublished ;
+long certi::ObjectClassNotSubscribed::_type = certi::e_ObjectClassNotSubscribed ;
+long certi::ObjectNotKnown::_type = certi::e_ObjectNotKnown ;
+long certi::ObjectAlreadyRegistered::_type = certi::e_ObjectAlreadyRegistered ;
+long certi::OwnershipAcquisitionPending::_type = certi::e_OwnershipAcquisitionPending ;
+long certi::RegionInUse::_type = certi::e_RegionInUse ;
+long certi::RegionNotKnown::_type = certi::e_RegionNotKnown ;
+long certi::RestoreInProgress::_type = certi::e_RestoreInProgress ;
+long certi::RestoreNotRequested::_type = certi::e_RestoreNotRequested ;
+long certi::RTIinternalError::_type = certi::e_RTIinternalError ;
+long certi::SpaceNotDefined::_type = certi::e_SpaceNotDefined ;
+long certi::SaveInProgress::_type = certi::e_SaveInProgress ;
+long certi::SaveNotInitiated::_type = certi::e_SaveNotInitiated ;
+long certi::SpecifiedSaveLabelDoesNotExist::_type = certi::e_SpecifiedSaveLabelDoesNotExist ;
+long certi::SynchronizationPointLabelWasNotAnnounced::_type = certi::e_SynchronizationPointLabelWasNotAnnounced ;
+long certi::TimeAdvanceAlreadyInProgress::_type = certi::e_TimeAdvanceAlreadyInProgress ;
+long certi::TimeAdvanceWasNotInProgress::_type = certi::e_TimeAdvanceWasNotInProgress ;
+long certi::TimeConstrainedAlreadyEnabled::_type = certi::e_TimeConstrainedAlreadyEnabled ;
+long certi::TimeConstrainedWasNotEnabled::_type = certi::e_TimeConstrainedWasNotEnabled ;
+long certi::TimeRegulationAlreadyEnabled::_type = certi::e_TimeRegulationAlreadyEnabled ;
+long certi::TimeRegulationWasNotEnabled::_type = certi::e_TimeRegulationWasNotEnabled ;
+long certi::UnableToPerformSave::_type = certi::e_UnableToPerformSave ;
+long certi::ValueCountExceeded::_type = certi::e_ValueCountExceeded ;
+long certi::ValueLengthExceeded::_type = certi::e_ValueLengthExceeded ;
 
 //  TypeException managing (how to obtain TypeException from Exception name ?)
-long certi::FederateNotPublishing::type = certi::e_FederateNotPublishing ;
-long certi::FederateNotSubscribing::type = certi::e_FederateNotSubscribing ;
-long certi::InvalidObjectHandle::type = certi::e_InvalidObjectHandle ;
-long certi::SecurityError::type = certi::e_SecurityError ;
-long certi::CouldNotOpenRID::type = certi::e_CouldNotOpenRID ;
-long certi::ErrorReadingRID::type = certi::e_ErrorReadingRID ;
-long certi::FederationAlreadyPaused::type = certi::e_FederationAlreadyPaused ;
-long certi::FederationNotPaused::type = certi::e_FederationNotPaused ;
-long certi::AttributeNotSubscribed::type = certi::e_AttributeNotSubscribed ;
-long certi::FederateAlreadyPaused::type = certi::e_FederateAlreadyPaused ;
-long certi::FederateDoesNotExist::type = certi::e_FederateDoesNotExist ;
-long certi::FederateNameAlreadyInUse::type = certi::e_FederateNameAlreadyInUse ;
-long certi::FederateNotPaused::type = certi::e_FederateNotPaused ;
-long certi::IDsupplyExhausted::type = certi::e_IDsupplyExhausted ;
-long certi::InvalidDivestitureCondition::type = certi::e_InvalidDivestitureCondition ;
-long certi::InvalidFederationTimeDelta::type = certi::e_InvalidFederationTimeDelta ;
-long certi::InvalidRoutingSpace::type = certi::e_InvalidRoutingSpace ;
-long certi::NoPauseRequested::type = certi::e_NoPauseRequested ;
-long certi::NoResumeRequested::type = certi::e_NoResumeRequested ;
-long certi::TooManyIDsRequested::type = certi::e_TooManyIDsRequested ;
-long certi::UnimplementedService::type = certi::e_UnimplementedService ;
-long certi::UnknownLabel::type = certi::e_UnknownLabel ;
-long certi::NetworkError::type = certi::e_NetworkError ;
-long certi::NetworkSignal::type = certi::e_NetworkSignal ;
+long certi::FederateNotPublishing::_type = certi::e_FederateNotPublishing ;
+long certi::FederateNotSubscribing::_type = certi::e_FederateNotSubscribing ;
+long certi::InvalidObjectHandle::_type = certi::e_InvalidObjectHandle ;
+long certi::CouldNotOpenRID::_type = certi::e_CouldNotOpenRID ;
+long certi::ErrorReadingRID::_type = certi::e_ErrorReadingRID ;
+long certi::AttributeNotSubscribed::_type = certi::e_AttributeNotSubscribed ;
+long certi::FederationAlreadyPaused::_type = certi::e_FederationAlreadyPaused ;
+long certi::FederationNotPaused::_type = certi::e_FederationNotPaused ;
+long certi::SecurityError::_type = certi::e_SecurityError ;
+long certi::FederateAlreadyPaused::_type = certi::e_FederateAlreadyPaused ;
+long certi::FederateDoesNotExist::_type = certi::e_FederateDoesNotExist ;
+long certi::FederateNameAlreadyInUse::_type = certi::e_FederateNameAlreadyInUse ;
+long certi::FederateNotPaused::_type = certi::e_FederateNotPaused ;
+long certi::IDsupplyExhausted::_type = certi::e_IDsupplyExhausted ;
+long certi::InvalidDivestitureCondition::_type = certi::e_InvalidDivestitureCondition ;
+long certi::InvalidFederationTimeDelta::_type = certi::e_InvalidFederationTimeDelta ;
+long certi::InvalidRoutingSpace::_type = certi::e_InvalidRoutingSpace ;
+long certi::NoPauseRequested::_type = certi::e_NoPauseRequested ;
+long certi::NoResumeRequested::_type = certi::e_NoResumeRequested ;
+long certi::TooManyIDsRequested::_type = certi::e_TooManyIDsRequested ;
+long certi::UnimplementedService::_type = certi::e_UnimplementedService ;
+long certi::UnknownLabel::_type = certi::e_UnknownLabel ;
+long certi::NetworkError::_type = certi::e_NetworkError ;
+long certi::NetworkSignal::_type = certi::e_NetworkSignal ;
 
 // $Id: Exception.cc,v 3.16 2008/11/25 16:32:14 gotthardp Exp $
diff --exclude=CVS -Nru certi/libCERTI/Exception.hh certi.new/libCERTI/Exception.hh
--- certi/libCERTI/Exception.hh	2008-10-28 13:07:26.000000000 +0100
+++ certi.new/libCERTI/Exception.hh	2008-12-05 17:37:51.000000000 +0100
@@ -26,7 +26,8 @@
 #ifndef _CERTI_EXCEPTION_HH
 #define _CERTI_EXCEPTION_HH
 
-#define MAX_EXCEPTION_REASON_LENGTH 256
+#include "certi.hh"
+#include <string>
 
 namespace certi {
 
@@ -138,6 +139,134 @@
     e_NetworkSignal
 } TypeException ;
 
+class CERTI_EXPORT Exception
+{
+public:
+    const std::string _reason;
+    const char *_name;
+
+    Exception(const std::string &reason)
+        : _reason(reason) { }
+    virtual ~Exception() { }
+
+    virtual long getType() const = 0;
+};
+
+#define CERTI_EXCEPTION(A) \
+    class CERTI_EXPORT A : public Exception { \
+    public: \
+        static long _type; \
+        A(const std::string &reason) : Exception(reason) { _name = #A; } \
+        long getType() const { return _type; } \
+};
+
+// RTI Exceptions for use inside libCERTI
+CERTI_EXCEPTION(ArrayIndexOutOfBounds)
+CERTI_EXCEPTION(AsynchronousDeliveryAlreadyDisabled)
+CERTI_EXCEPTION(AsynchronousDeliveryAlreadyEnabled)
+CERTI_EXCEPTION(AttributeAcquisitionWasNotRequested)
+CERTI_EXCEPTION(AttributeAcquisitionWasNotCanceled)
+CERTI_EXCEPTION(AttributeAlreadyBeingAcquired)
+CERTI_EXCEPTION(AttributeAlreadyBeingDivested)
+CERTI_EXCEPTION(AttributeAlreadyOwned)
+CERTI_EXCEPTION(AttributeDivestitureWasNotRequested)
+CERTI_EXCEPTION(AttributeNotDefined)
+CERTI_EXCEPTION(AttributeNotKnown)
+CERTI_EXCEPTION(AttributeNotOwned)
+CERTI_EXCEPTION(AttributeNotPublished)
+CERTI_EXCEPTION(ConcurrentAccessAttempted)
+CERTI_EXCEPTION(CouldNotDiscover)
+CERTI_EXCEPTION(CouldNotOpenFED)
+CERTI_EXCEPTION(CouldNotRestore)
+CERTI_EXCEPTION(DeletePrivilegeNotHeld)
+CERTI_EXCEPTION(DimensionNotDefined)
+CERTI_EXCEPTION(EnableTimeConstrainedPending)
+CERTI_EXCEPTION(EnableTimeConstrainedWasNotPending)
+CERTI_EXCEPTION(EnableTimeRegulationPending)
+CERTI_EXCEPTION(EnableTimeRegulationWasNotPending)
+CERTI_EXCEPTION(ErrorReadingFED)
+CERTI_EXCEPTION(EventNotKnown)
+CERTI_EXCEPTION(FederateAlreadyExecutionMember)
+CERTI_EXCEPTION(FederateInternalError)
+CERTI_EXCEPTION(FederateLoggingServiceCalls)
+CERTI_EXCEPTION(FederateNotExecutionMember)
+CERTI_EXCEPTION(FederateOwnsAttributes)
+CERTI_EXCEPTION(FederateWasNotAskedToReleaseAttribute)
+CERTI_EXCEPTION(FederatesCurrentlyJoined)
+CERTI_EXCEPTION(FederationExecutionAlreadyExists)
+CERTI_EXCEPTION(FederationExecutionDoesNotExist)
+CERTI_EXCEPTION(FederationTimeAlreadyPassed)
+CERTI_EXCEPTION(HandleValuePairMaximumExceeded)
+CERTI_EXCEPTION(InteractionClassNotDefined)
+CERTI_EXCEPTION(InteractionClassNotKnown)
+CERTI_EXCEPTION(InteractionClassNotPublished)
+CERTI_EXCEPTION(InteractionClassNotSubscribed)
+CERTI_EXCEPTION(InteractionParameterNotDefined)
+CERTI_EXCEPTION(InteractionParameterNotKnown)
+CERTI_EXCEPTION(InvalidExtents)
+CERTI_EXCEPTION(InvalidFederationTime)
+CERTI_EXCEPTION(InvalidHandleValuePairSetContext)
+CERTI_EXCEPTION(InvalidLookahead)
+CERTI_EXCEPTION(InvalidOrderingHandle)
+CERTI_EXCEPTION(InvalidRegionContext)
+CERTI_EXCEPTION(InvalidResignAction)
+CERTI_EXCEPTION(InvalidRetractionHandle)
+CERTI_EXCEPTION(InvalidTransportationHandle)
+CERTI_EXCEPTION(MemoryExhausted)
+CERTI_EXCEPTION(NameNotFound)
+CERTI_EXCEPTION(ObjectClassNotDefined)
+CERTI_EXCEPTION(ObjectClassNotKnown)
+CERTI_EXCEPTION(ObjectClassNotPublished)
+CERTI_EXCEPTION(ObjectClassNotSubscribed)
+CERTI_EXCEPTION(ObjectNotKnown)
+CERTI_EXCEPTION(ObjectAlreadyRegistered)
+CERTI_EXCEPTION(OwnershipAcquisitionPending)
+CERTI_EXCEPTION(RegionInUse)
+CERTI_EXCEPTION(RegionNotKnown)
+CERTI_EXCEPTION(RestoreInProgress)
+CERTI_EXCEPTION(RestoreNotRequested)
+CERTI_EXCEPTION(RTIinternalError)
+CERTI_EXCEPTION(SpaceNotDefined)
+CERTI_EXCEPTION(SaveInProgress)
+CERTI_EXCEPTION(SaveNotInitiated)
+CERTI_EXCEPTION(SpecifiedSaveLabelDoesNotExist)
+CERTI_EXCEPTION(SynchronizationPointLabelWasNotAnnounced)
+CERTI_EXCEPTION(TimeAdvanceAlreadyInProgress)
+CERTI_EXCEPTION(TimeAdvanceWasNotInProgress)
+CERTI_EXCEPTION(TimeConstrainedAlreadyEnabled)
+CERTI_EXCEPTION(TimeConstrainedWasNotEnabled)
+CERTI_EXCEPTION(TimeRegulationAlreadyEnabled)
+CERTI_EXCEPTION(TimeRegulationWasNotEnabled)
+CERTI_EXCEPTION(UnableToPerformSave)
+CERTI_EXCEPTION(ValueCountExceeded)
+CERTI_EXCEPTION(ValueLengthExceeded)
+
+// Additional CERTI exceptions
+CERTI_EXCEPTION(FederateNotPublishing)
+CERTI_EXCEPTION(FederateNotSubscribing)
+CERTI_EXCEPTION(InvalidObjectHandle)
+CERTI_EXCEPTION(SecurityError)
+CERTI_EXCEPTION(CouldNotOpenRID)
+CERTI_EXCEPTION(ErrorReadingRID)
+CERTI_EXCEPTION(FederationAlreadyPaused)
+CERTI_EXCEPTION(FederationNotPaused)
+CERTI_EXCEPTION(AttributeNotSubscribed)
+CERTI_EXCEPTION(FederateAlreadyPaused)
+CERTI_EXCEPTION(FederateDoesNotExist)
+CERTI_EXCEPTION(FederateNameAlreadyInUse)
+CERTI_EXCEPTION(FederateNotPaused)
+CERTI_EXCEPTION(IDsupplyExhausted)
+CERTI_EXCEPTION(InvalidDivestitureCondition)
+CERTI_EXCEPTION(InvalidFederationTimeDelta)
+CERTI_EXCEPTION(InvalidRoutingSpace)
+CERTI_EXCEPTION(NoPauseRequested)
+CERTI_EXCEPTION(NoResumeRequested)
+CERTI_EXCEPTION(TooManyIDsRequested)
+CERTI_EXCEPTION(UnimplementedService)
+CERTI_EXCEPTION(UnknownLabel)
+CERTI_EXCEPTION(NetworkSignal)
+CERTI_EXCEPTION(NetworkError)
+
 } // namespace certi
 
 #endif // _CERTI_EXCEPTION_HH
diff --exclude=CVS -Nru certi/libCERTI/Extent.hh certi.new/libCERTI/Extent.hh
--- certi/libCERTI/Extent.hh	2007-09-03 15:26:05.000000000 +0200
+++ certi.new/libCERTI/Extent.hh	2008-11-26 12:58:01.000000000 +0100
@@ -26,6 +26,7 @@
 #define CERTI_EXTENT_HH
 
 #include "certi.hh"
+#include "Exception.hh"
 
 #include <vector>
 #include <utility>
diff --exclude=CVS -Nru certi/libCERTI/FedRegion.hh certi.new/libCERTI/FedRegion.hh
--- certi/libCERTI/FedRegion.hh	2008-06-23 15:25:05.000000000 +0200
+++ certi.new/libCERTI/FedRegion.hh	2008-11-26 14:28:52.000000000 +0100
@@ -32,7 +32,7 @@
 
 class RoutingSpace ;
 
-class CERTI_EXPORT FedRegion : public BaseRegion, public RTI::Region
+class CERTI_EXPORT FedRegion : public BaseRegion
 {
 public:
     FedRegion(RegionHandle, SpaceHandle, const std::vector<Extent> &);
